<template>
	<div class="container">
	<section v-if="this.tallyIsComputed">
		<h1 class="title is-1">Risultato</h1>
		<h2 class="subtitle">Dettagli contratto di Voto</h2>
		<p>Indirizzo contratto: {{$route.query.contract_address}}</p>
		<p>Data e ora di inizio: {{this.dateTimeStart}}</p>
		<p>Data e ora di fine: {{this.dateTimeEnd}}</p>

		<h3 class="title is-3">Quesito</h3>
		<h4 class="title is-4">{{this.question}}</h4>

		<p>Risultato:</p>
		<ul>
			<li v-for="option in this.optionListWithResults">
				<div class="box">
					<p>{{option.optionText}}: {{option.optionResult}}</p>
				</div>
			</li>
		</ul>
	</section>

	<section v-else>
		<h1>Risultato non ancora disponibile</h1>
	</section>
	</div>
</template>

<script>
	import { ethers } from 'ethers'
	import Contract from '../static/contracts/Voting.json'
	import StackModal from '@innologica/vue-stackable-modal'

	export default {
		layout: 'none',

		components: {
			StackModal,
		},

		async mounted() {
			this.loadingComponent = this.$buefy.loading.open()
			const provider = ethers.getDefaultProvider('ropsten')

			this.contractAddress = this.$route.query.contract_address
			this.VotingContract = new ethers.Contract(this.contractAddress, Contract.abi, provider)

			const tally = await this.VotingContract.tally()
			this.tallyIsComputed = tally.tallyIsComputed
			this.validVotes = tally.validVotes.toString()

			if (this.tallyIsComputed) {
				this.question = await this.VotingContract.getQuestion()

				this.startTimestamp = await this.VotingContract.voteStartTimestamp()
				this.endTimestamp = await this.VotingContract.voteEndTimestamp()

				this.dateTimeStart = new Date(this.startTimestamp.toNumber()*1000)
				this.dateTimeEnd = new Date(this.endTimestamp.toNumber()*1000)

				const totalOptionsWithResults = await this.VotingContract.ballotScheme()
				for (let i = 0; i < totalOptionsWithResults.totalOptionsVoting; i++) {
					const optionText = await this.VotingContract.getOption(i)
					const optionResult = await this.VotingContract.getVoteResultForOption(i)
					alert(optionResult)
					const optionWithResult = {
						optionResult: optionResult,
						optionText: optionText
					}
					this.optionListWithResults.push(optionWithResult)
				}
			}

			this.loadingComponent.close()
		},

		methods: {
			
		},

		data() {
			return {
				validVotes: 0,
				tallyIsComputed: false,
				isElectionFinished: false,
				VotingContract: null,
				startTimestamp: 0,
				endTimestamp: 0,
				loadingComponent: null,
				tallyCreated: false,
				contractAddress: '',
				show: false,
				question: '',
				dateTimeStart: '',
				dateTimeEnd: '',
				optionListWithResults: [],
			}
		}
	}
</script>

<style>
    @import "https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css";
</style>

<style lang="scss">
    @import "../node_modules/@innologica/vue-stackable-modal/src/assets/transitions/translate-fade.scss";
    @import "../assets/scss/modal.scss";
</style>